%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Distance = Get_Point_Line_Distance(Point_location, Line_location_1, Line_location_2)

% Если входные параметры - номера узлов, то существование узлов должно проверяться вне данной функции до ее вызова
% Несовпадение координат Line_location_1 и Line_location_2 должно проверяться вне данной функции до ее вызова

global DB_NODES;
global AT_NODES;

if (size(Point_location,1) == 3)
	Point = Point_location;
else
    Point = DB_NODES{AT_NODES(Point_location)}.Location;
end

if (size(Line_location_1,1) == 3)
	Line_point_1 = Line_location_1;
else
    Line_point_1 = DB_NODES{AT_NODES(Line_location_1)}.Location;
end

if (size(Line_location_2,1) == 3)
	Line_point_2 = Line_location_2;
else
    Line_point_2 = DB_NODES{AT_NODES(Line_location_2)}.Location;
end

Vector_1 = Line_point_2 - Line_point_1;
Vector_2 = Point - Line_point_1;

Distance = norm(cross(Vector_1,Vector_2)) / norm(Vector_1);
